package partie_2;

import java.io.IOException;
import java.io.OutputStream;
import java.util.ArrayList;

public class Illustration {

	private int length = 50;
	private int height = 40;
	
	ArrayList<Form> forms = new ArrayList<Form>();
	
	public void addForm(Form f)
	{
		forms.add(f);
	}
	public void removeForm(int index)
	{
		forms.remove(index);
	}
	
	public void draw()
	{
		try {
			this.draw(System.out);
		} catch (IOException e) {
			//should never happens on standard out.
			e.printStackTrace(); 
		}
	}
	
	
	public void draw(OutputStream out) throws IOException
	{
		for (int i = 0; i < height; i++) {
			for (int j = 0; j < length; j++) {
				char c = ' ';
				for (Form form : forms) {
					if(form.isOn(new Point(i,j))) c = form.getColor();
				}
				out.write(c);
			}
			System.out.println();
		}
	} 
	
	public static void main(String[] args) {
		Illustration picture = new Illustration();
		picture.addForm(new Circle(new Point(10,10),'c',8));
		picture.addForm(new Circle(new Point(10,40),'c',8));
		Circle circle2 = new Circle(new Point(15,20),'o',6);
		circle2.setFilled();
		picture.addForm(circle2);
		Circle circle3 = new Circle(new Point(15,35),'o',6);
		circle3.setFilled();
		picture.addForm(circle3);
		Line line = new Line(new Point(30, 0), '\\', new Point(25,35));
		picture.addForm(line);
		picture.draw();
		
	}
}
